##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName
# sampledir (sampledir)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for CAMP

%define name		ksm-camp
%define version		0.0.4
%define release		1.1.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	CAMP (Control File Assisted Media Player)
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Multimedia/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	% {_tmppath}/% {name}-% {version}-% {release}-root
BuildArch:	%{_arch}
#BuildRequires:	ksm-camppkg,ksm-campcapab
Requires:	sox, vlc, xine-ui
Requires:	ksm-libstd-sh >= 5.0.0-0.0.0
#Provides:	ksm-campd
#Conflicts:	ksm-campd-other,libksm-camp == 0.0.0
#Obsoletes:	myksm-campd

%description
This package contains the media player CAMP and a program to build the 
necessary media control files.

The package contains the following programs:

 camp, makemcf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) % {_confdir}/ksm-camp.conf
#%config % {_confdir}/ksm-camp.conf
#%config % {_scnfdir}/ksm-camp
%{_confdir}/camp.conf
#%attr(644,root,root)% {_scnfdir}/ksm-camp

#%attr(744,root,root)% {_rcdir}/ksm-campd
#%attr(777,root,root)% {_bindir}/rcksm-campd

%attr(755,root,root)%{_bindir}/camp
%attr(755,root,root)%{_bindir}/makemcf

%{_datadir}/RELEASE
%{_datadir}/VERSION
%{_datadir}/template-audio.mcf
%{_datadir}/template-video.mcf

/usr/share/applications/camp.desktop
%{_icondir}/16x16/apps/camp.png
%{_icondir}/22x22/apps/camp.png
%{_icondir}/32x32/apps/camp.png
%{_icondir}/48x48/apps/camp.png
%{_icondir}/64x64/apps/camp.png
#% {_icondir}/128x128/apps/camp.png
#/usr/share/pixmaps/camp.png

%docdir %{_man1dir}
%{_man1dir}/camp.1.gz
%{_man1dir}/makemcf.1.gz

#%docdir % {_man8dir}
#% {_man8dir}/ksm-campd.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
test -e %{_confdir}/camp.conf && cp %{_confdir}/camp.conf %{_confdir}/camp.conf.rpmsave
#test -e %{_scnfdir}/camp && cp %{_scnfdir}/camp %{_scnfdir}/camp.rpmsave

# disable camp and stop campd
#test -x %{_bindir}/toggleksm-camp && %{_bindir}/toggleksm-camp -d -q > /dev/null 2>&1
#test -x %{_rcdir}/campd && %{_rcdir}/campd stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
xdg-desktop-menu uninstall \
	/usr/share/applications/camp.desktop

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname. config file needs a version at first cnfvar!
cf=%{_confdir}/camp.conf
cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
c='' s='' t='' cnt=0 i=0 ret=0

#rcfile='' updcmd='' u='' usr=''

# enable sample daemon
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
xdg-desktop-menu install --novendor \
	/usr/share/applications/camp.desktop

if [ "$1" == 1 ]; then					# install package
	echo "Configure $cf"
#	echo "Users must create HOME/.camprc with update-camp"
else							# upgrade package
	# update global conf
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave

		# update conf vars START -------------------------------------
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi
		# update conf vars STOP --------------------------------------

#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------

		# compare new conf vars <--> old conf vars
		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Check $cf"
		fi
	fi

#	# update all users conf START ----------------------------------------
#	rcfile='.camprc'
#	updcmd="%{_bindir}/update-camp -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.camprc with update-camp"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	test -e %{_confdir}/camp.conf && cp %{_confdir}/camp.conf %{_confdir}/camp.conf.rpmsave
	#test -e %{_scnfdir}/camp.conf && cp %{_scnfdir}/camp.conf %{_scnfdir}/camp.conf.rpmsave

	# disable camp daemon and stop campd
	#test -x %{_bindir}/togglecamp && %{_bindir}/togglecamp -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/campd && %{_rcdir}/campd stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	xdg-desktop-menu uninstall \
		/usr/share/applications/camp.desktop
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-campdir
#else							# upgrade package
fi
exit 0

%changelog
* Mon Jan 06 2025 Repomaster <repomaster@kaesmann-online.de> 0.0.4-1.1.0
- 'camp' has been revised/improved.

* Sat Apr 13 2024 Repomaster <repomaster@kaesmann-online.de> 0.0.4-1.0.0
- 'camp' has been revised/improved
  (fix an error when using m3u).

* Tue Dec 05 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.4-0.0.0
- 'camp' has been revised/improved
  (introducing the config var IVIEWER).

* Tue Oct 10 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.3-8.0.0
- 'camp' has been revised/improved.

* Sat Feb 18 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.3-7.0.0
- 'camp' has been revised/improved.

* Mon Dec 12 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-6.3.0
- 'camp' has been revised/improved
  (dialog functions).

* Tue Nov 29 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-6.2.0
- 'camp' has been revised/improved
  (dialog functions).

* Mon Nov 28 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-6.1.0
- 'camp' has been revised/improved
  (dialog functions).

* Mon Nov 14 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-6.0.0
- 'camp' has been revised/improved
  (better use of big terminals).

* Fri Mar 25 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.2.0
- 'camp' has been revised/improved.

* Mon Mar 14 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.1.0
- Following programs have been revised/improved:
  camp, makemcf

* Mon Mar 07 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.0.0
- Following programs have been revised/improved:
  camp, makemcf

* Sun Mar 06 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-4.0.0
- 'camp' has been revised/improved.

* Fri Feb 18 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-3.0.0
- Following programs have been revised/improved:
  camp, makemcf

* Sat Feb 05 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-2.1.0
- Following programs have been revised/improved:
  camp, makemcf

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-2.0.0
- Update to the libfuncstd-sh 4.0.0

* Wed Mar 17 2021 Repomaster <repomaster@kaesmann-online.de> 0.0.3-1.3.0
- The program makemcf has been revised/improved
  (fixed first line with -A).

* Wed Oct 14 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-1.2.0
- Fixed missing desktop file camp.desktop

* Sun Oct 11 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-1.1.0
- camp has been revised/improved.
- makemcf has been revised/improved
  (fixed an error with -A).

* Sat Oct 03 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-1.0.0
- The program makemcf has been revised/improved
  (added option -A).

* Fri Mar 13 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.6.0
- The program camp has been revised/improved
  (fixed a common error while checking
  the output from dialog).

* Fri Feb 28 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.5.0
- camp has been revised/improved
  (handling of .wlu playlists).

* Fri Feb 21 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.4.0
- The program has been revised/improved
  (internal structure and Help system).

* Fri Jan 24 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.3.0
- The first dialog after program start has been removed.
  Now we start immediately in the file selection dialog.

* Sun Apr 07 2019 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.2.0
- Added the possibility to show a textfile.

* Wed Dec 19 2018 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.1.0
- Error fixed in line 569
  (missing "0").

* Thu Jan 11 2018 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.0.0
- Now we use a global config file.
- The docu has been revised.

* Thu Aug 24 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-3.1.0
- All programs have been revised.

* Tue Aug 22 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-3.0.0
- Added the possibility to play wav files.

* Mon Apr 10 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-2.4.0
- All progs have been revised
  (fixed init for var 'err').
- The docu has been revised.

* Fri Jan 20 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-2.3.0
- All scripts have been revised
  (using section GET OPTIONS).

* Thu Jan 19 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-2.2.0
- All scripts have been revised
  (using new function GetOpt).

* Thu Jan 12 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-2.1.0
- All scripts have been revised.

* Fri Dec 09 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-2.0.0
- The scripts camp and makemcf have been revised
  (fixed a bug in return a value from a function).
- The script camp.sh has been removed.

* Sun Dec 04 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-1.5.0
- The scripts camp and makemcf have been revised
  (fixed a bug in function count_tabs).

* Sun Dec 04 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-1.4.0
- The scripts camp and makemcf have been revised.

* Fri Dec 02 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-1.3.0
- The script camp has been revised.

* Thu Dec 01 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-1.2.0
- The script camp has been revised
  (invocing of player).

* Tue Nov 29 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-1.1.0
- The scripts camp and makemcf have been revised.

* Sun Nov 27 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-1.0.0
- The package has been revised (added icons).

* Sun Nov 27 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.6.0
- The package has been revised
  (added camp.desktop).

* Sun Nov 27 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.5.0
- The player camp has been revised
  (support for m3u files has been improved).

* Sat Nov 26 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.4.0
- The player camp has been revised
  (now we have support for m3u files).

* Sat Nov 26 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.3.0
- The player camp and the script 'makemcf' have been
  revised (the audio part has been overworked).

* Sat Nov 26 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.2.0
- The player camp has been revised.

* Fri Nov 25 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.1.0
- The player camp has been revised.

* Thu Nov 24 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.0.0
- The player has renamed to camp.sh
- Added the new player camp (it uses
  an interface with text graphic).

* Wed Nov 23 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised.

* Wed Nov 23 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- This is the 1. version.
- The package contains following programs:
  camp:		Play medi files
  makemcf:	create/update media control files
